diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.43/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.42/src/wifi/test/wifi-phy-ofdma-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-phy-ofdma-test.cc	2024-10-09 16:41:10.140657000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -61,11 +50,11 @@
 NS_LOG_COMPONENT_DEFINE("WifiPhyOfdmaTest");
 
 static const uint8_t DEFAULT_CHANNEL_NUMBER = 36;
-static const uint32_t DEFAULT_FREQUENCY = 5180; // MHz
+static const MHz_u DEFAULT_FREQUENCY = 5180;
 static const WifiPhyBand DEFAULT_WIFI_BAND = WIFI_PHY_BAND_5GHZ;
-static const uint16_t DEFAULT_CHANNEL_WIDTH = 20; // MHz
-static const uint16_t DEFAULT_GUARD_WIDTH =
-    DEFAULT_CHANNEL_WIDTH; // MHz (expanded to channel width to model spectrum mask)
+static const MHz_u DEFAULT_CHANNEL_WIDTH = 20;
+static const MHz_u DEFAULT_GUARD_WIDTH =
+    DEFAULT_CHANNEL_WIDTH; // expanded to channel width to model spectrum mask
 
 /**
  * HE PHY slightly modified so as to return a given
@@ -186,14 +175,14 @@
     /**
      * Wrapper to InterferenceHelper method.
      *
-     * \param energyW the minimum energy (W) requested
+     * \param energy the minimum energy requested
      * \param band identify the requested band
      *
      * \returns the expected amount of time the observed
      *          energy on the medium for a given band will
      *          be higher than the requested threshold.
      */
-    Time GetEnergyDuration(double energyW, WifiSpectrumBandInfo band);
+    Time GetEnergyDuration(Watt_u energy, WifiSpectrumBandInfo band);
 
     /**
      * \return a const pointer to the HE PHY instance
@@ -279,9 +268,9 @@
 }
 
 Time
-OfdmaSpectrumWifiPhy::GetEnergyDuration(double energyW, WifiSpectrumBandInfo band)
+OfdmaSpectrumWifiPhy::GetEnergyDuration(Watt_u energy, WifiSpectrumBandInfo band)
 {
-    return m_interference->GetEnergyDuration(energyW, band);
+    return m_interference->GetEnergyDuration(energy, band);
 }
 
 Ptr<const HePhy>
@@ -442,8 +431,8 @@
     Ptr<OfdmaSpectrumWifiPhy> m_phySta3;    ///< PHY of STA 3
     Ptr<WaveformGenerator> m_phyInterferer; ///< PHY of interferer
 
-    uint16_t m_frequency;        ///< frequency in MHz
-    uint16_t m_channelWidth;     ///< channel width in MHz
+    MHz_u m_frequency;           ///< frequency
+    MHz_u m_channelWidth;        ///< channel width
     Time m_expectedPpduDuration; ///< expected duration to send MU PPDU
 };
 
@@ -483,16 +472,16 @@
 {
     NS_LOG_FUNCTION(this << rxStaId1 << rxStaId2);
     WifiConstPsduMap psdus;
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_MU,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         m_channelWidth,
-                                         false,
-                                         false);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_MU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          m_channelWidth,
+                          false,
+                          false};
     HeRu::RuType ruType = HeRu::RU_106_TONE;
     if (m_channelWidth == 20)
     {
@@ -816,11 +805,12 @@
     m_phySta2->AssignStreams(streamNumber);
     m_phySta3->AssignStreams(streamNumber);
 
-    auto channelNum = std::get<0>(*WifiPhyOperatingChannel::FindFirst(0,
-                                                                      m_frequency,
-                                                                      m_channelWidth,
-                                                                      WIFI_STANDARD_80211ax,
-                                                                      WIFI_PHY_BAND_5GHZ));
+    auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                         m_frequency,
+                                                         m_channelWidth,
+                                                         WIFI_STANDARD_80211ax,
+                                                         WIFI_PHY_BAND_5GHZ)
+                          ->number;
 
     m_phyAp->SetOperatingChannel(
         WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
@@ -959,9 +949,9 @@
     Bands bands;
     bands.push_back(bandInfo);
 
-    Ptr<SpectrumModel> SpectrumInterferenceRu1 = Create<SpectrumModel>(bands);
-    Ptr<SpectrumValue> interferencePsdRu1 = Create<SpectrumValue>(SpectrumInterferenceRu1);
-    double interferencePower = 0.1; // watts
+    auto SpectrumInterferenceRu1 = Create<SpectrumModel>(bands);
+    auto interferencePsdRu1 = Create<SpectrumValue>(SpectrumInterferenceRu1);
+    Watt_u interferencePower{0.1};
     *interferencePsdRu1 = interferencePower / ((m_channelWidth / 2) * 20e6);
 
     Simulator::Schedule(Seconds(3.0) + MicroSeconds(50),
@@ -1313,8 +1303,8 @@
     Ptr<OfdmaSpectrumWifiPhy> m_phySta2;    ///< PHY of STA 2
     Ptr<WaveformGenerator> m_phyInterferer; ///< PHY of interferer
 
-    uint16_t m_frequency;    ///< frequency in MHz
-    uint16_t m_channelWidth; ///< channel width in MHz
+    MHz_u m_frequency;    ///< frequency
+    MHz_u m_channelWidth; ///< channel width
 
     uint8_t m_indexSubchannel; ///< Index of the subchannel (starting from 0) that should contain an
                                ///< interference and be punctured during the test run
@@ -1357,16 +1347,16 @@
 {
     NS_LOG_FUNCTION(this << rxStaId1 << rxStaId2);
     WifiConstPsduMap psdus;
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_MU,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         m_channelWidth,
-                                         false,
-                                         false);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_MU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          m_channelWidth,
+                          false,
+                          false};
 
     HeRu::RuType ruType =
         puncturedSubchannels.empty()
@@ -1636,11 +1626,12 @@
     m_phySta1->AssignStreams(streamNumber);
     m_phySta2->AssignStreams(streamNumber);
 
-    auto channelNum = std::get<0>(*WifiPhyOperatingChannel::FindFirst(0,
-                                                                      m_frequency,
-                                                                      m_channelWidth,
-                                                                      WIFI_STANDARD_80211ax,
-                                                                      WIFI_PHY_BAND_5GHZ));
+    auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                         m_frequency,
+                                                         m_channelWidth,
+                                                         WIFI_STANDARD_80211ax,
+                                                         WIFI_PHY_BAND_5GHZ)
+                          ->number;
 
     m_phyAp->SetOperatingChannel(
         WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
@@ -1660,9 +1651,9 @@
     Bands bands;
     bands.push_back(bandInfo);
 
-    Ptr<SpectrumModel> spectrumInterference = Create<SpectrumModel>(bands);
-    Ptr<SpectrumValue> interferencePsd = Create<SpectrumValue>(spectrumInterference);
-    double interferencePower = 0.1; // watts
+    auto spectrumInterference = Create<SpectrumModel>(bands);
+    auto interferencePsd = Create<SpectrumValue>(spectrumInterference);
+    Watt_u interferencePower{0.1};
     *interferencePsd = interferencePower / 10e6;
 
     Simulator::Schedule(Seconds(0.0),
@@ -1744,7 +1735,8 @@
     // Send MU PPDU with two PSDUs addressed to STA 1 and STA 2 with preamble puncturing:
     // the punctured 20 MHz subchannel is the one that has interference
     std::vector<bool> puncturedSubchannels;
-    for (std::size_t i = 0; i < (m_channelWidth / 20); ++i)
+    const std::size_t num20MhzSubchannels = m_channelWidth / 20;
+    for (std::size_t i = 0; i < num20MhzSubchannels; ++i)
     {
         if (i == m_indexSubchannel)
         {
@@ -1917,11 +1909,12 @@
     m_phyAp->SetErrorRateModel(apErrorModel);
     m_phyAp->AddChannel(spectrumChannel);
     m_phyAp->ConfigureStandard(WIFI_STANDARD_80211ax);
-    auto channelNum = std::get<0>(*WifiPhyOperatingChannel::FindFirst(0,
-                                                                      DEFAULT_FREQUENCY,
-                                                                      DEFAULT_CHANNEL_WIDTH,
-                                                                      WIFI_STANDARD_80211ax,
-                                                                      WIFI_PHY_BAND_5GHZ));
+    auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                         DEFAULT_FREQUENCY,
+                                                         DEFAULT_CHANNEL_WIDTH,
+                                                         WIFI_STANDARD_80211ax,
+                                                         WIFI_PHY_BAND_5GHZ)
+                          ->number;
     m_phyAp->SetOperatingChannel(
         WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, WIFI_PHY_BAND_5GHZ, 0});
     m_phyAp->SetDevice(apDev);
@@ -2047,16 +2040,16 @@
 TestUlOfdmaPpduUid::SendMuPpdu()
 {
     WifiConstPsduMap psdus;
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_MU,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         DEFAULT_CHANNEL_WIDTH,
-                                         false,
-                                         false);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_MU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          DEFAULT_CHANNEL_WIDTH,
+                          false,
+                          false};
 
     uint16_t rxStaId1 = 1;
     HeRu::RuSpec ru1(HeRu::RU_106_TONE, 1, true);
@@ -2099,18 +2092,18 @@
     WifiConstPsduMap psdus1;
     WifiConstPsduMap psdus2;
 
-    WifiTxVector txVector1 = WifiTxVector(HePhy::GetHeMcs7(),
-                                          0,
-                                          WIFI_PREAMBLE_HE_TB,
-                                          1600,
-                                          1,
-                                          1,
-                                          0,
-                                          DEFAULT_CHANNEL_WIDTH,
-                                          false,
-                                          false);
-    WifiTxVector txVector2 = txVector1;
-    WifiTxVector trigVector = txVector2;
+    WifiTxVector txVector1{HePhy::GetHeMcs7(),
+                           0,
+                           WIFI_PREAMBLE_HE_TB,
+                           NanoSeconds(1600),
+                           1,
+                           1,
+                           0,
+                           DEFAULT_CHANNEL_WIDTH,
+                           false,
+                           false};
+    WifiTxVector txVector2{txVector1};
+    WifiTxVector trigVector{txVector2};
 
     uint16_t rxStaId1 = 1;
     HeRu::RuSpec ru1(HeRu::RU_106_TONE, 1, false);
@@ -2121,13 +2114,13 @@
     trigVector.SetMode(HePhy::GetHeMcs7(), rxStaId1);
     trigVector.SetNss(1, rxStaId1);
 
-    Ptr<Packet> pkt1 = Create<Packet>(1000);
+    auto pkt1 = Create<Packet>(1000);
     WifiMacHeader hdr1;
     hdr1.SetType(WIFI_MAC_QOSDATA);
     hdr1.SetQosTid(0);
     hdr1.SetAddr1(Mac48Address("00:00:00:00:00:00"));
     hdr1.SetSequenceNumber(1);
-    Ptr<WifiPsdu> psdu1 = Create<WifiPsdu>(pkt1, hdr1);
+    auto psdu1 = Create<WifiPsdu>(pkt1, hdr1);
     psdus1.insert(std::make_pair(rxStaId1, psdu1));
 
     uint16_t rxStaId2 = 2;
@@ -2139,24 +2132,24 @@
     trigVector.SetMode(HePhy::GetHeMcs9(), rxStaId2);
     trigVector.SetNss(1, rxStaId2);
 
-    Ptr<Packet> pkt2 = Create<Packet>(1500);
+    auto pkt2 = Create<Packet>(1500);
     WifiMacHeader hdr2;
     hdr2.SetType(WIFI_MAC_QOSDATA);
     hdr2.SetQosTid(0);
     hdr2.SetAddr1(Mac48Address("00:00:00:00:00:00"));
     hdr2.SetSequenceNumber(2);
-    Ptr<WifiPsdu> psdu2 = Create<WifiPsdu>(pkt2, hdr2);
+    auto psdu2 = Create<WifiPsdu>(pkt2, hdr2);
     psdus2.insert(std::make_pair(rxStaId2, psdu2));
 
-    Time txDuration1 = m_phySta1->CalculateTxDuration(psdu1->GetSize(),
-                                                      txVector1,
-                                                      m_phySta1->GetPhyBand(),
-                                                      rxStaId1);
-    Time txDuration2 = m_phySta2->CalculateTxDuration(psdu2->GetSize(),
-                                                      txVector2,
-                                                      m_phySta1->GetPhyBand(),
-                                                      rxStaId2);
-    Time txDuration = std::max(txDuration1, txDuration2);
+    const auto txDuration1 = m_phySta1->CalculateTxDuration(psdu1->GetSize(),
+                                                            txVector1,
+                                                            m_phySta1->GetPhyBand(),
+                                                            rxStaId1);
+    const auto txDuration2 = m_phySta2->CalculateTxDuration(psdu2->GetSize(),
+                                                            txVector2,
+                                                            m_phySta1->GetPhyBand(),
+                                                            rxStaId2);
+    const auto txDuration = std::max(txDuration1, txDuration2);
 
     txVector1.SetLength(
         HePhy::ConvertHeTbPpduDurationToLSigLength(txDuration, txVector1, m_phySta1->GetPhyBand())
@@ -2176,24 +2169,24 @@
 TestUlOfdmaPpduUid::SendSuPpdu(uint16_t txStaId)
 {
     WifiConstPsduMap psdus;
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_SU,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         DEFAULT_CHANNEL_WIDTH,
-                                         false,
-                                         false);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_SU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          DEFAULT_CHANNEL_WIDTH,
+                          false,
+                          false};
 
-    Ptr<Packet> pkt = Create<Packet>(1000);
+    auto pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
     hdr.SetAddr1(Mac48Address::GetBroadcast());
     hdr.SetSequenceNumber(1);
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
     psdus.insert(std::make_pair(SU_STA_ID, psdu));
 
     switch (txStaId)
@@ -2275,10 +2268,10 @@
      * \param uid the UID used to identify a set of HE TB PPDUs belonging to the same UL-MU
      * transmission
      * \param staId the STA ID
-     * \param txPowerWatts the TX power in watts
+     * \param txPower the TX power
      * \param payloadSize the size of the payload in bytes
      */
-    void RxHeTbPpdu(uint64_t uid, uint16_t staId, double txPowerWatts, size_t payloadSize);
+    void RxHeTbPpdu(uint64_t uid, uint16_t staId, Watt_u txPower, size_t payloadSize);
 
     /**
      * Receive OFDMA part of HE TB PPDU function.
@@ -2332,7 +2325,7 @@
       m_trigVector(HePhy::GetHeMcs7(),
                    0,
                    WIFI_PREAMBLE_HE_TB,
-                   1600,
+                   NanoSeconds(1600),
                    1,
                    1,
                    0,
@@ -2390,20 +2383,20 @@
 void
 TestMultipleHeTbPreambles::RxHeTbPpdu(uint64_t uid,
                                       uint16_t staId,
-                                      double txPowerWatts,
+                                      Watt_u txPower,
                                       size_t payloadSize)
 {
     WifiConstPsduMap psdus;
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_TB,
-                                         1600,
-                                         1,
-                                         1,
-                                         0,
-                                         DEFAULT_CHANNEL_WIDTH,
-                                         false,
-                                         false);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_TB,
+                          NanoSeconds(1600),
+                          1,
+                          1,
+                          0,
+                          DEFAULT_CHANNEL_WIDTH,
+                          false,
+                          false};
 
     HeRu::RuSpec ru(HeRu::RU_106_TONE, staId, false);
     txVector.SetRu(ru, staId);
@@ -2412,35 +2405,36 @@
 
     m_trigVector.SetHeMuUserInfo(staId, {ru, 7, 1});
 
-    Ptr<Packet> pkt = Create<Packet>(payloadSize);
+    auto pkt = Create<Packet>(payloadSize);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
     hdr.SetAddr1(Mac48Address("00:00:00:00:00:00"));
     hdr.SetSequenceNumber(1);
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
     psdus.insert(std::make_pair(staId, psdu));
 
-    Time ppduDuration =
+    auto ppduDuration =
         m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand(), staId);
-    Ptr<HePpdu> ppdu = Create<HePpdu>(psdus,
-                                      txVector,
-                                      m_phy->GetOperatingChannel(),
-                                      ppduDuration,
-                                      uid,
-                                      HePpdu::PSD_NON_HE_PORTION);
+    auto ppdu = Create<HePpdu>(psdus,
+                               txVector,
+                               m_phy->GetOperatingChannel(),
+                               ppduDuration,
+                               uid,
+                               HePpdu::PSD_NON_HE_PORTION);
 
     // Send non-OFDMA part
-    Time nonOfdmaDuration = m_phy->GetHePhy()->CalculateNonHeDurationForHeTb(txVector);
-    uint32_t centerFrequency = m_phy->GetHePhy()->GetCenterFrequencyForNonHePart(txVector, staId);
-    uint16_t ruWidth = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
-    uint16_t channelWidth = ruWidth < 20 ? 20 : ruWidth;
+    const auto nonOfdmaDuration = m_phy->GetHePhy()->CalculateNonHeDurationForHeTb(txVector);
+    const auto centerFrequency =
+        m_phy->GetHePhy()->GetCenterFrequenciesForNonHePart(ppdu, staId).front();
+    MHz_u ruWidth = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
+    MHz_u channelWidth = ruWidth < 20 ? 20 : ruWidth;
     Ptr<SpectrumValue> rxPsd = WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
         centerFrequency,
         channelWidth,
-        txPowerWatts,
+        txPower,
         m_phy->GetGuardBandwidth(channelWidth));
-    Ptr<WifiSpectrumSignalParameters> rxParams = Create<WifiSpectrumSignalParameters>();
+    auto rxParams = Create<WifiSpectrumSignalParameters>();
     rxParams->psd = rxPsd;
     rxParams->txPhy = nullptr;
     rxParams->duration = nonOfdmaDuration;
@@ -2457,16 +2451,16 @@
     m_phy->StartRx(rxParams, nullptr);
 
     // Schedule OFDMA part
-    Ptr<HePpdu> ppduOfdma = DynamicCast<HePpdu>(ppdu->Copy()); // since flag will be modified
+    auto ppduOfdma = DynamicCast<HePpdu>(ppdu->Copy()); // since flag will be modified
     ppduOfdma->SetTxPsdFlag(HePpdu::PSD_HE_PORTION);
     const auto band = m_phy->GetHePhy()->GetRuBandForRx(txVector, staId);
-    Ptr<SpectrumValue> rxPsdOfdma =
-        WifiSpectrumValueHelper::CreateHeMuOfdmTxPowerSpectralDensity(DEFAULT_FREQUENCY,
+    auto rxPsdOfdma =
+        WifiSpectrumValueHelper::CreateHeMuOfdmTxPowerSpectralDensity({DEFAULT_FREQUENCY},
                                                                       DEFAULT_CHANNEL_WIDTH,
-                                                                      txPowerWatts,
+                                                                      txPower,
                                                                       DEFAULT_GUARD_WIDTH,
                                                                       band.indices);
-    Ptr<WifiSpectrumSignalParameters> rxParamsOfdma = Create<WifiSpectrumSignalParameters>();
+    auto rxParamsOfdma = Create<WifiSpectrumSignalParameters>();
     rxParamsOfdma->psd = rxPsd;
     rxParamsOfdma->txPhy = nullptr;
     rxParamsOfdma->duration = ppduDuration - nonOfdmaDuration;
@@ -2545,7 +2539,7 @@
     int64_t streamNumber = 0;
     m_phy->AssignStreams(streamNumber);
 
-    double txPowerWatts = 0.01;
+    Watt_u txPower{0.01};
 
     {
         // Verify a single UL MU transmission with two stations belonging to the same BSS
@@ -2555,14 +2549,14 @@
                             this,
                             uids[0],
                             1,
-                            txPowerWatts,
+                            txPower,
                             1001);
         Simulator::Schedule(Seconds(1) + NanoSeconds(100),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[0],
                             2,
-                            txPowerWatts,
+                            txPower,
                             1002);
         // Check that we received a single UL MU transmission with the corresponding UID
         Simulator::Schedule(Seconds(1.0) + MicroSeconds(1),
@@ -2583,28 +2577,28 @@
                             this,
                             uids[0],
                             1,
-                            txPowerWatts,
+                            txPower,
                             1001);
         Simulator::Schedule(Seconds(2) + NanoSeconds(100),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[0],
                             2,
-                            txPowerWatts,
+                            txPower,
                             1002);
         Simulator::Schedule(Seconds(2) + NanoSeconds(200),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[1],
                             1,
-                            txPowerWatts / 2,
+                            txPower / 2,
                             1003);
         Simulator::Schedule(Seconds(2) + NanoSeconds(300),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[1],
                             2,
-                            txPowerWatts / 2,
+                            txPower / 2,
                             1004);
         // Check that we received the correct reception of 2 UL MU transmissions with the
         // corresponding UIDs
@@ -2627,28 +2621,28 @@
                             this,
                             uids[0],
                             1,
-                            txPowerWatts / 2,
+                            txPower / 2,
                             1001);
         Simulator::Schedule(Seconds(3) + NanoSeconds(100),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[0],
                             2,
-                            txPowerWatts / 2,
+                            txPower / 2,
                             1002);
         Simulator::Schedule(Seconds(3) + NanoSeconds(200),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[1],
                             1,
-                            txPowerWatts,
+                            txPower,
                             1003);
         Simulator::Schedule(Seconds(3) + NanoSeconds(300),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[1],
                             2,
-                            txPowerWatts,
+                            txPower,
                             1004);
         // Check that we received the correct reception of 2 UL MU transmissions with the
         // corresponding UIDs
@@ -2671,28 +2665,28 @@
                             this,
                             uids[0],
                             1,
-                            txPowerWatts,
+                            txPower,
                             1001);
         Simulator::Schedule(Seconds(4) + NanoSeconds(100),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[0],
                             2,
-                            txPowerWatts,
+                            txPower,
                             1002);
         Simulator::Schedule(Seconds(4) + MicroSeconds(5),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[1],
                             1,
-                            txPowerWatts,
+                            txPower,
                             1003);
         Simulator::Schedule(Seconds(4) + MicroSeconds(5) + NanoSeconds(100),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[1],
                             2,
-                            txPowerWatts,
+                            txPower,
                             1004);
         // Check that we received the correct reception of the first UL MU transmission with the
         // corresponding UID (second one dropped)
@@ -2719,28 +2713,28 @@
                             this,
                             uids[0],
                             1,
-                            txPowerWatts,
+                            txPower,
                             1001);
         Simulator::Schedule(Seconds(5) + NanoSeconds(100),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[0],
                             2,
-                            txPowerWatts,
+                            txPower,
                             1002);
         Simulator::Schedule(Seconds(5) + MicroSeconds(50),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[1],
                             1,
-                            txPowerWatts,
+                            txPower,
                             1003);
         Simulator::Schedule(Seconds(5) + MicroSeconds(50) + NanoSeconds(100),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[1],
                             2,
-                            txPowerWatts,
+                            txPower,
                             1004);
         // Check that we received the correct reception of the first UL MU transmission with the
         // corresponding UID (second one dropped)
@@ -2767,14 +2761,14 @@
                             this,
                             uids[0],
                             1,
-                            txPowerWatts,
+                            txPower,
                             1001);
         Simulator::Schedule(Seconds(6) + NanoSeconds(500),
                             &TestMultipleHeTbPreambles::RxHeTbPpdu,
                             this,
                             uids[0],
                             2,
-                            txPowerWatts,
+                            txPower,
                             1002);
         // Check that we received a single UL MU transmission with the corresponding UID
         Simulator::Schedule(Seconds(6.0) + MicroSeconds(1),
@@ -2832,9 +2826,9 @@
         m_lastRxSuccess = false;
     }
 
-    void NotifyTxStart(Time duration, double txPowerDbm) override
+    void NotifyTxStart(Time duration, dBm_u txPower) override
     {
-        NS_LOG_FUNCTION(this << duration << txPowerDbm);
+        NS_LOG_FUNCTION(this << duration << txPower);
     }
 
     void NotifyCcaBusyStart(Time duration,
@@ -3009,9 +3003,9 @@
     /**
      * Set the PSD limit
      * \param phy the PHY
-     * \param psdLimit the PSD limit in dBm/MHz
+     * \param psdLimit the PSD limit
      */
-    void SetPsdLimit(Ptr<WifiPhy> phy, double psdLimit);
+    void SetPsdLimit(Ptr<WifiPhy> phy, dBm_per_MHz_u psdLimit);
 
     /**
      * Generate interference function
